/*
 * Copyright (c) 2005-2014, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * WSO2 Inc. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */
package org.wso2.andes.server.output;

import org.wso2.andes.server.output.ProtocolOutputConverter.Factory;
import org.wso2.andes.server.protocol.AMQProtocolSession;
import org.wso2.andes.framing.ProtocolVersion;

import java.util.Map;
import java.util.HashMap;

public class ProtocolOutputConverterRegistry
{

    private static final Map<ProtocolVersion, Factory> _registry =
            new HashMap<ProtocolVersion, Factory>();


    static
    {
        register(ProtocolVersion.v8_0, org.wso2.andes.server.output.amqp0_8.ProtocolOutputConverterImpl.getInstanceFactory());
        register(ProtocolVersion.v0_9, org.wso2.andes.server.output.amqp0_9.ProtocolOutputConverterImpl.getInstanceFactory());
        register(ProtocolVersion.v0_91, org.wso2.andes.server.output.amqp0_9_1.ProtocolOutputConverterImpl.getInstanceFactory());
    }

    private static void register(ProtocolVersion version, Factory converter)
    {

        _registry.put(version,converter);
    }


    public static ProtocolOutputConverter getConverter(AMQProtocolSession session)
    {
        return _registry.get(session.getProtocolVersion()).newInstance(session);
    }
}
